precision lowp float;
uniform sampler2D mixerTex;
uniform float iGlobalTime;
uniform vec2 iResolution;
vec2 iMouse = vec2(sin(iGlobalTime*0.1),0.7);
float rand(vec2 co) {
    return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453);
}

float smin( float a, float b, float k ) {
    float res = exp( -k*a ) + exp( -k*b );
    return -log( res )/k;
}
mat3 rotY(in float a) {
    return mat3( cos(a), 0.0, sin(a),
                 0.0,    1.0, 0.0,
                -sin(a), 0.0, cos(a)
                );
}
float udRoundBox( vec3 p, vec3 b, float r ){
  return length(max(abs(p)-b,0.0))-r;
}
float sdSphere( vec3 p, float s ){
  return length(p)-s;
}
float sdBox( vec3 p, vec3 b ){
  vec3 d = abs(p) - b;
  return min(max(d.x,max(d.y,d.z)),0.0) +
         length(max(d,0.0));
}


float palkki(in vec3 p){
    
    float finalDistance = 10000000.;
    
    finalDistance = min(finalDistance, udRoundBox( p-vec3(0.0), vec3(2.0,11. ,2.0) , 0.1) );
    vec3 p2 = p;
    vec3 p3 = p;
    vec3 p4 = p;
    
    p3.zyx *= rotY(3.14145*0.5);
    p3.yxz *= rotY(3.14145*0.25);
    p.zyx *= rotY(3.14145*0.5);
    finalDistance = min(finalDistance, udRoundBox( (p3-vec3(2.0,0.0,0.0)), vec3(0.2,1.0,1.0) , 0.1 ) );
    finalDistance = min(finalDistance, udRoundBox( (p3-vec3(2.0,0.0,0.0)), vec3(0.4,0.8,0.8) , 0.1 ) );
    finalDistance = min(finalDistance, udRoundBox( (p-vec3(2.0,-0.8,0.0)), vec3(0.4,1.0,0.8) , 0.1 ) );

    return finalDistance;
}

void objectGroup0Light(in vec3 p, out float finalDistance){
    finalDistance= min(finalDistance,sdBox( p-vec3(0.,sin(length(p.xz)/2.)/4.+sin(rand(floor(p.xz))*3.141*2.6+iGlobalTime/2.)/3.,0.), vec3(444.,1.,444.) ));
}

void objectGroup1Light(in vec3 p, out float finalDistance){

    float dist3 = 111111111111.;
    for(float i=0.0; i<3.0; i++){
        float r_0 = cos(i*128.);
        float r_1 = sin(i*53535.);
        vec3 bubble_pos = vec3(sin(r_0+i*r_1+iGlobalTime)*0.5, sin(i+iGlobalTime)*0.5+1.5, sin(r_1+i*i+r_0*iGlobalTime)*0.5 );
        dist3 = smin(dist3,sdSphere(p-bubble_pos*2.7,1.2+sin(i+iGlobalTime)/12.), 5.);
    }
    vec3 p2 = vec3(p.x,p.y,abs(p.z/2.));
    if(p2.z>1.6)
    dist3 = min(dist3,palkki(p2-vec3(0.,3.0,5.0)));

    finalDistance = min(finalDistance,dist3);
}


float calculateDistance(in vec3 p, out vec3 color, out float reflectiveValue) {
    float finalDistance = 10000000.;
    
    color = vec3(1.2, 1.0, 0.8);
    reflectiveValue = 0.2;
    objectGroup0Light(p, finalDistance);
    objectGroup1Light(p, finalDistance);
    
    return finalDistance;
}

float calculateDistanceLight(in vec3 p) {
    float finalDistance = 10000000.;
    
    objectGroup0Light(p, finalDistance);
    objectGroup1Light(p, finalDistance);
    return finalDistance;
}

float traceToLight(vec3 rayPosition, vec3 normalVector, vec3 lightSource){
    vec3 ro = rayPosition + normalVector/128.;
    vec3 rd = normalize(lightSource - rayPosition);
    float t = 0.01;
    float k = 1.6;
    float res = 1.0;
    for( int i=0; i<23; i++ )
    {
        float h = calculateDistanceLight(ro + rd*t);
        h = max( h, 0.0 );
        res = min( res, k*h/t );
        t += clamp( h, 0.001, 0.9 );
        if( h<1./1024. && length(ro + rd*t)>10.0) break;
    }
    return clamp(res,0.01,9.0);
}
vec3 tracer(vec3 rayStartPosition, vec3 rayDirection) {
    const float epsilon = 1./128.;
    
    vec3 rayPosition = rayStartPosition;

    vec3 normalVector;
    float dist = 0.0;
    vec3 returnColor = vec3(0.0);
    vec3 finalColor = vec3(0.0);
    vec3 lightSource = vec3(-12.,6.+iGlobalTime/3.,0.) ;
    float reflectiveValue = 1.0;
    float reflectionNow = 1.0;
    float finalLight = 1.0;
    
    float possibleFogLight = 1.0;
    
    for(float k=0.; k<2.; k++) {
        for(float i=0.; i<31.; i++) {
            vec3 color;
            float stepable = calculateDistance(rayPosition, color, reflectiveValue);
            dist += stepable;
            rayPosition = rayStartPosition + dist * rayDirection;

            if( length(rayPosition)>10.){
                vec3 lightDir = (lightSource-rayStartPosition);
                lightDir = normalize(lightDir);
                float directLight = dot(rayDirection, lightDir);
                returnColor+=min(max( pow(directLight,33.1) * vec3(1.7,1.1,.9) * 0.4, 0.01),1.);
                return returnColor;
            }

            if( abs(stepable) <= epsilon){
                vec3 C;
                float dummy = 0.0;
                normalVector = vec3(    calculateDistanceLight(rayPosition+vec3(epsilon,0,0))-calculateDistanceLight(rayPosition+vec3(-epsilon,0,0)),
                                        calculateDistanceLight(rayPosition+vec3(0,epsilon,0))-calculateDistanceLight(rayPosition+vec3(0,-epsilon,0)),
                                        calculateDistanceLight(rayPosition+vec3(0,0,epsilon))-calculateDistanceLight(rayPosition+vec3(0,0,-epsilon)));
                normalVector = normalize(normalVector);
                float light = traceToLight(rayPosition, normalVector, lightSource);
                finalLight = min(finalLight, light);
                float lightDistance = distance(rayStartPosition,lightSource);
                
                finalColor = color * vec3(dot(normalVector, -rayDirection));
                
                
                vec3 lightDir = (lightSource-rayPosition);
                lightDir = normalize(lightDir);
                float directLight = dot(normalVector, lightDir);
                reflectionNow = max(reflectionNow,reflectiveValue);
                
                
                returnColor += ( vec3(finalLight*max(1.5*directLight*vec3(1.7,1.1,0.9),0.01)) / (k*4.8/reflectionNow + 1.0)) * finalColor;
  
                    
                break;
                
            }
        }
        dist = 0.01;
        rayStartPosition = rayPosition + normalVector;
        rayPosition = rayStartPosition;
        rayDirection = reflect(rayDirection, normalVector);
    } 
    vec3 lightDir = (lightSource-rayStartPosition);
    lightDir = normalize(lightDir);
    float directLight = dot(rayDirection, lightDir);
    returnColor+=min(max( pow(directLight,33.1) * vec3(1.7,1.1,.9) * 0.08, 0.01),1.);
    return returnColor;
}
vec3 piip() {
    vec3 cameraPosition = vec3( 4., 4.+iGlobalTime/6., -9.+iGlobalTime/4.);
    vec2 uv = 2.0 * gl_FragCoord.xy / iResolution.xy - 1.0;
    
    float aspect = iResolution.x / iResolution.y;
    vec3 direction = normalize(vec3(.5 * uv * vec2(aspect, 1.0), 1. ));
    direction.yxz *= rotY(-0.16-iGlobalTime/42.);
    cameraPosition *= rotY(-3.141/2. + iGlobalTime/26.);
    direction *= rotY(-3.141/2. - iGlobalTime/18.);
    direction.zxy *= rotY(1./(1.+iGlobalTime/16.));
    return tracer(cameraPosition, direction);
}

void main(){
    
    vec2 uv = 2.0 * gl_FragCoord.xy / iResolution.xy - 1.0;
    float aspect = iResolution.x / iResolution.y;
        gl_FragColor = vec4(piip(),1.);
}